#!/usr/bin/php -Cq
<?php

   require_once('inc/IMConfigure.php');

   ###
   # definitions of socket - BEGIN
   #
      define('URI', '0.0.0.0');
      define('TARGET_NON_SECURITY', TRANSPORT_NON_SECURITY . '://' . URI  . ':' . PORT_NON_SECURITY);
      define('SOCKET_NON_SECURITY', stream_socket_server(TARGET_NON_SECURITY, $errno_non_security, $errstr_non_security, STREAM_SERVER_BIND | STREAM_SERVER_LISTEN));
   #
   # definitions of socket - END
   ###


   if ( !SOCKET_NON_SECURITY )
   {
      printf("NON SECURITY:\n(%d) %s", $errno_non_security, $errstr_non_security);
      exit(0);
   }

   include 'inc/Jabberd2.abstract.php';

   $master = array(SOCKET_NON_SECURITY);

   $users = array();

   $send = false;

   while ( 1 )
   {
      $read = $master;
      $_w = NULL;
      $_e = NULL;
       
      $mod_fd = @stream_select($read, $_w , $_e , READ_SOCKET_AFTER_OF );

      if ( $mod_fd === FALSE )
         break;

      for ( $i = 0; $i < $mod_fd; ++$i )
      {
         if ( $read[$i] === SOCKET_NON_SECURITY )
         {
            $conn_non_security = stream_socket_accept(SOCKET_NON_SECURITY);
            $master[] = &$conn_non_security;
         }
         else
         {
            $sock_data = fread($read[$i], 1024);
            if ( strlen($sock_data) === 0 )
            {
               $key_to_del = array_search($read[$i], $master, TRUE);
               fclose($read[$i]);
               unset($master[$key_to_del]);
            }
            else if ( $sock_data === FALSE )
            {
               $key_to_del = array_search($read[$i], $master, TRUE);
               unset($master[$key_to_del]);
            }
            else
            {
               $headers = (split("\n", $sock_data));

               preg_match('/^(GET|POST) \/(.+) HTTP\/1\.1/U', $headers[0], $request);
               preg_match('/^Host: \w*:(.+)/', $headers[1], $host);

               $conn = &$conn_non_security;

               $request = explode(';', $request[2]);

               if ( $request[0] == CONNECT && isset($request[1]) && !isset($users[$request[1]]) )
               {
                  connect($users, $request[1]);
               }

               if ( $request[0] == CLOSE && isset($request[1]) && isset($users[$request[1]]) )
               {   
               	close($request[1]);
               }

               fclose($read[$i]);
               unset($master[array_search($read[$i], $master)]);
            }
         }
      }	
      
      foreach ( $users as $key => $val )
      {
         if($users[$key]['time0'] != $users[$key]['time1']  )
         {
         	$users[$key]['time1'] = $users[$key]['time0'];
         	$users[$key]['attempt'] = 0;
         	readSocket($key);
         	//readSocket($users, $key);
         }
         else
         {
				$users[$key]['attempt']++;
				if( $users[$key]['attempt'] > 5 )
				{
     				$users[$key]['jabber']->disconnect();
     				unset($users[$key]);     				
				}
				else
				{
					readSocket($key);
					//readSocket($users, $key);
				}         	
         }

         //print_r("Session : " . $key . " | Count : " . count($users) . " | time 0 : " . $users[$key]['time0'] . " | time 1 : " . $users[$key]['time1'] . " | tentativas : " . $users[$key]['attempt'] . " \n");
      }

   }
	
	
   exit(0);

	
   function connect(&$pUsers, $pSession)
   {
      $sessionpath = explode(';', session_save_path());
      foreach ( $sessionpath as $path )
      {
         $path = ( strrpos($path, '/') == strlen($path) - 1 ) ? $path : $path . '/';

         if ( file_exists($path . 'sess_' . $pSession) )
         {
            session_id($pSession);

            ob_start();
            session_start();
            ob_clean();
            ob_end_flush();

            $is_user = isset($_SESSION['phpgw_info']['instant_messenger']['user']) and isset($_SESSION['phpgw_info']['instant_messenger']['passwd']);
            if ( $is_user )
            {
               $_user     = $_SESSION['phpgw_info']['instant_messenger']['user'];
               $_pass     = $_SESSION['phpgw_info']['instant_messenger']['passwd'];
               $_server   = $_SESSION['phpgw_info']['instant_messenger']['name_jabber'];
               $_port     = $_SESSION['phpgw_info']['instant_messenger']['port_jabber'];
               $_resource = $_SESSION['phpgw_info']['instant_messenger']['resource_jabber'];
               $_time     = time();
               $_SESSION['phpgw_info']['instant_messenger']['time'] = $_time;
               $_SESSION['phpgw_info']['instant_messenger']['socket'] = NULL;
               $_SESSION['phpgw_info']['instant_messenger']['socket']['in'] = NULL;
               $_SESSION['phpgw_info']['instant_messenger']['socket']['out'] = array();
               $_SESSION['phpgw_info']['instant_messenger']['socket']['out']['message'] = NULL;
               $_SESSION['phpgw_info']['instant_messenger']['socket']['block'] = false;

               session_write_close();

               $a = new Jabberd2;
               if ( ($a->connect($_user . '@' . $_server . '/' . $_resource . ':' . $_port, $_pass)) )
               {
                  $pUsers[$pSession] = array();
                  $pUsers[$pSession]['jabber'] = $a;
                  $pUsers[$pSession]['time0'] = $_time;
						$pUsers[$pSession]['time1'] = 0;                  
                  $pUsers[$pSession]['attempt'] = 0;
               }
               else
               {
                  unset($a);
               }
               break;
            }
            session_write_close();
         }
      }
   }

   function close($pUser)
   {
      global $users;
      $users[$pUser]['jabber']->disconnect();
      unset($users[$pUser]);
   }

   //function readSocket(&$pUsers, $pSession)
   function readSocket($pSession)
   {
      global $users;
      global $send;
      $sessionpath = explode(';', session_save_path());
      foreach ( $sessionpath as $path )
      {
         $path = ( strrpos($path, '/') == strlen($path) - 1 ) ? $path : $path . '/';

         if ( file_exists($path . 'sess_' . $pSession) )
         {
            session_id($pSession);

            ob_start();
            session_start();
            ob_clean();
            ob_end_flush();

            $is_user = isset($_SESSION['phpgw_info']['instant_messenger']['user']) and isset($_SESSION['phpgw_info']['instant_messenger']['passwd']);
            if ( $is_user )
            {
               $users[$pSession]['time0'] = $_SESSION['phpgw_info']['instant_messenger']['time'];
					$readSocket = $users[$pSession]['jabber']->readSocket();
               
               if ( $readSocket !== false )
               {
                  if ( !empty($readSocket) )
                  {
                     $_SESSION['phpgw_info']['instant_messenger']['socket']['in'] .= $readSocket;
                  }

						if ( $_SESSION['phpgw_info']['instant_messenger']['socket']['out'] )
							foreach ( $_SESSION['phpgw_info']['instant_messenger']['socket']['out'] as $action => $value )
							{
								if ( $action === 'message' )
								{
									if ( !is_null($value) )
									{
										$users[$pSession]['jabber']->writeSocket($value);
										$_SESSION['phpgw_info']['instant_messenger']['socket']['out']['message'] = NULL;
									}
								}
								else if ( $action === 'vcard' )
								{
									if ( !empty($value) )
									{
										foreach ( $value as $key => $val )
										{
											$users[$pSession]['jabber']->getVcard($val);
											unset($_SESSION['phpgw_info']['instant_messenger']['socket']['out']['vcard'][$key]);
										}
									}
								}
								else
								{
									if ( method_exists($users[$pSession]['jabber'], $action) )
										if ( $value )
											$users[$pSession]['jabber']->$action($value);
										else
											$users[$pSession]['jabber']->$action();
									unset($_SESSION['phpgw_info']['instant_messenger']['socket']['out'][$action]);
								}
							}
               }
               else
               {
                  close($pSession);
               }
               session_write_close();
               break;
            }
            session_write_close();
         }
      }
   }
?>
